org.eclipse.viatra.query.runtime.localsearch.planner.cost.impl

## Class HybridMatcherConstraintCostFunction

- java.lang.Object
- - org.eclipse.viatra.query.runtime.localsearch.planner.cost.impl.StatisticsBasedConstraintCostFunction
  - - org.eclipse.viatra.query.runtime.localsearch.planner.cost.impl.IndexerBasedConstraintCostFunction
    - - org.eclipse.viatra.query.runtime.localsearch.planner.cost.impl.HybridMatcherConstraintCostFunction

- All Implemented Interfaces:
    ICostFunction

  Deprecated.
  `StatisticsBasedConstraintCostFunction` should use `IQueryResultProvider.estimateCardinality(org.eclipse.viatra.query.runtime.matchers.tuple.TupleMask, org.eclipse.viatra.query.runtime.matchers.util.Accuracy)`

      @Deprecated
      public class HybridMatcherConstraintCostFunction
      extends IndexerBasedConstraintCostFunction

  This cost function is intended to be used on hybrid configuration, with the strict restriction than any non-flattened positive pattern call is executed with Rete engine. This implementation provides the exact number of matches by invoking the result provider for the called pattern.

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.localsearch.planner.cost.impl.StatisticsBasedConstraintCostFunction

      `DEFAULT_COST, EVAL_UNWIND_EXTENSION_FACTOR, INVERSE_NAVIGATION_PENALTY_DEFAULT, INVERSE_NAVIGATION_PENALTY_GENERIC, MAX_COST`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `HybridMatcherConstraintCostFunction()` Deprecated.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected double` | `_calculateCost(PositivePatternCall patternCall, IConstraintEvaluationContext context)` Deprecated.

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.localsearch.planner.cost.impl.IndexerBasedConstraintCostFunction

      `projectionSize`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.localsearch.planner.cost.impl.StatisticsBasedConstraintCostFunction

      `_calculateCost, _calculateCost, _calculateCost, _calculateCost, _calculateCost, _calculateCost, _calculateCost, _calculateCost, _calculateCost, _calculateCost, _calculateCost, _calculateCost, apply, bucketSize, calculateBinaryCost, calculateBinaryExtendCost, calculateCost, calculateUnaryConstraintCost, countTuples, navigatesThroughFunctionalDependency, navigatesThroughFunctionalDependency, navigatesThroughFunctionalDependencyInverse`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### HybridMatcherConstraintCostFunction

          public HybridMatcherConstraintCostFunction()

      Deprecated.

  - ### Method Detail

    - #### _calculateCost

          protected double _calculateCost(PositivePatternCall patternCall,
                                          IConstraintEvaluationContext context)

      Deprecated.
      Overrides:
        `_calculateCost` in class `StatisticsBasedConstraintCostFunction`